class TCallback
{
  private:
    int			    m_refCnt; 		/* Reference Count */
    
  public:
    /* Constructor/Destructor */
    TCallback(void) {}
    ~TCallback(void) {}

    virtual HRESULT Reset(LPVOID clientData);
    virtual HRESULT Next(LPVOID clientData, CLIPFORMAT *pcfFormatOut);
    virtual HRESULT GetData(LPVOID clientData, UINT type, char **ppStrOut);
    virtual HRESULT SetData(LPVOID clientData, UINT type, LONG x, LONG y,
			    char *str, char *eventStr);
    virtual ULONG   AddRef() {
	m_refCnt++;
	return m_refCnt;
    }
    virtual ULONG   Release() {
	m_refCnt--;
	if (m_refCnt == 0L) {
	    delete this;
	    return 0L;
	}
	return m_refCnt;
    }
};

typedef class TCallback *PTCallback;
